/*
 *	main.c
 *
 *	~jh[
 *
 *	* Tue Sep 5 04:41:00 JST 2004 Naoyuki Sawa
 *	- 1st[XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* R[hlݒB */
	record = 1000;

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x003
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
//#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result = -1;
	int x;
	int y;

	for(;;) {
		schedule();

		/* ʃNAB */
		memset(vbuff, 3, sizeof vbuff);

		/* X^[gHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* xIB */
		if(joy & TRG_LF) init_depth -= 100;
		if(joy & TRG_RI) init_depth += 100;
		if(init_depth <    0) init_depth =    0;
		if(init_depth > 5000) init_depth = 5000;

		/* ^Cg\B */
		sprite_draw(0, 0, SPR_TITLE, 0);

		/* XRA\B */
		x = 1;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 0x213, "DEPTH");
		y += 6;
		render_printf_framed(&render, x, y, 0x82, 0x213, "%4dm", game.depth <= 9999 ? game.depth : 9999);
		x = DISP_X - 4 * 5 - 2;
		y = 1;
		render_printf_framed(&render, x - 4, y, 0x82, 0x213, "RECORD");
		y += 6;
		render_printf_framed(&render, x, y, 0x82, 0x213, "%4dm", record <= 9999 ? record : 9999);

		/* x\B */
		x = (DISP_X - 5 * 15) / 2 - 1;
		y = DISP_Y - 35;
		if(init_depth == 0) {
			switch((unsigned)now / 5 % 3) {
			case 0: render_printf_framed(&render, x, y, 0x80, 0x213, "    %4dm` >  ", init_depth); break;
			case 1: render_printf_framed(&render, x, y, 0x80, 0x213, "    %4dm`  > ", init_depth); break;
			case 2: render_printf_framed(&render, x, y, 0x80, 0x213, "    %4dm`   >", init_depth); break;
			}
		} else if(init_depth == 5000) {
			switch((unsigned)now / 5 % 3) {
			case 0: render_printf_framed(&render, x, y, 0x80, 0x213, "  < %4dm`    ", init_depth); break;
			case 1: render_printf_framed(&render, x, y, 0x80, 0x213, " <  %4dm`    ", init_depth); break;
			case 2: render_printf_framed(&render, x, y, 0x80, 0x213, "<   %4dm`    ", init_depth); break;
			}
		} else {
			switch((unsigned)now / 5 % 3) {
			case 0: render_printf_framed(&render, x, y, 0x80, 0x213, "  < %4dm` >  ", init_depth); break;
			case 1: render_printf_framed(&render, x, y, 0x80, 0x213, " <  %4dm`  > ", init_depth); break;
			case 2: render_printf_framed(&render, x, y, 0x80, 0x213, "<   %4dm`   >", init_depth); break;
			}
		}

		/* vvg\B */
		x = (DISP_X - 4 * 8) / 2;
		y = DISP_Y - 6 * 3;
		render_string_framed(&render, x, y, " A START", 0x82, 0x203);
		y += 6;
		render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0x203);
	}

	return result;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int x;
	int y;
	int start;
	int sel;

	game_init();

	start = 0;
	for(;;) {
		schedule();

		/* Q[fB */
		if(joy & TRG_SELECT) {
			sel = 0;
			for(;;) {
				schedule();
				if(joy & TRG_SELECT) {
					break;
				}
				if(joy & TRG_AB) {
					if(sel) {
						goto L_EXIT;
					} else {
						break;
					}
				} 
				if(joy & TRG_LF) sel = 1;
				if(joy & TRG_RI) sel = 0;
				field_disp();
				x = 1;
				y = 34;
				render_rectangle_fill(&render, 0, y - 1, 73, 22, 0);
				render_string_framed(&render, x, y, "f܂H", 0x80, 0x130);
				y += 10;
				if(sel) {
					render_string_framed(&render, x    , y    , " xdr@@@>", 0x80, 0x130);
					render_string       (&render, x + 1, y + 1, "<@@@^mn ", 0x80,     2);
				} else {
					render_string       (&render, x + 1, y + 1, " xdr^@@>", 0x80,     2);
					render_string_framed(&render, x    , y    , "<@@@@mn ", 0x80, 0x130);
				}
			}
			schedule();
		}

		field_action();
		player_action();
		while(game.player_y - game.scroll_ofs > PLAYER_ROW * CELL_SIZE) {
			game.scroll_ofs++;
			scroll_action();
		}
		field_disp();

		/* GAMEOVER\AQ[I[o[B */
		if(game.player_stat == PS_MISS) {
			if(game.player_cnt >= SEC(2)) {
				if(joy & TRG_AB) {
					goto L_EXIT;
				}
				x = FIELD_X + (CELL_SIZE * FIELD_COLS - 8 * 8) / 2;
				y = 52;
				render_string_framed(&render, x, y, "GAMEOVER", 0x81, 0x203);
			}
			if(game.player_cnt >= SEC(10)) {
				goto L_EXIT;
			}
		}

		/* START!\B */
		if(start >= SEC(0.25) && start <= SEC(1.5)) {
			x = FIELD_X + (CELL_SIZE * FIELD_COLS - 8 * 6) / 2;
			y = 10;
			render_string_framed(&render, x, y, "START!", 0x81, 0x203);
		}
		start++;
	}
L_EXIT:
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof(GAME));

	/* V[hB */
	game.seed = pceTimerGetCount();
	game.gen_seed = pceTimerGetCount();

	/* ubNoB */
	game.scroll_depth = init_depth; /* ̃x̂߁B100mȏi܂ȂƂO */
	while(!game.field[PLAYER_ROW + 1][0].color) {
		game.scroll_ofs++;
		scroll_action();
	}
	game.scroll_depth = init_depth; /* ɐi񂾐[x߂ */

	/* vC[B */
	game.player_x = (FIELD_COLS - 1) / 2 * CELL_SIZE;
	game.player_y = (UPPER_ROWS - 1) * CELL_SIZE;
	game.player_dir = DIR_DN;
	game.air = 100;
}

/****************************************************************************
 *	fix_scan
 ****************************************************************************/

void
fix_scan(int col, int row, int color)
{
	CELL* cell;

	if(col < 0 || col > FIELD_COLS - 1) return; /* tB[hO */
	if(row < 0 || row > FIELD_ROWS - 1) return; /* tB[h */
	cell = &game.field[row][col];
	if(!cell->color) return; /* 󂫃Z */
	if(color) { /* Ff */
		if(cell->color != color) return; /* FႤ */
	} else { /* FfȂ(=ւ̑) */
		color = cell->color;
	}
	if(cell->mark) return; /* Œ}[Nς */

	/* Œ}[NB */
	cell->mark = 1;

	/* ւ̑BĂ邾Ȃ̂ŁAF̔fs܂B */
	fix_scan(col, row - 1, 0);

	/* ubNȊO(=GAJvZ)܂͏ŃubŃAэEւ܂B */
	if(!IS_BLOCK(color) || (cell->stat == CS_ERASE)) return;

	/* эEւ̑BF̂Ȃ̂ŁAF̔fs܂B
	 * * Î~EubN瓯F̏ŃubN֑Ă܂܂Aʂ͖肠܂B
	 *   [͊ԈĂ邯ǁAŃubN͊_Ƃđ邩łB
	 */
	fix_scan(col, row + 1, color);
	fix_scan(col - 1, row, color);
	fix_scan(col + 1, row, color);
}

/****************************************************************************
 *	erase_setup
 ****************************************************************************/

int
erase_scan(int col, int row, int color)
{
	CELL* cell;

	if(col < 0 || col > FIELD_COLS - 1) return 0; /* tB[hO */
	if(row < 0 || row > FIELD_ROWS - 1) return 0; /* tB[hO */
	cell = &game.field[row][col];
	if(!cell->color) return 0; /* 󂫃Z */
	if(cell->color != color) return 0; /* FႤ */
	if(cell->stat == CS_ERASE) return 0; /* ɏŏ */
	if(cell->mark) return 0; /* ς */

	/* ς݃}[NB */
	cell->mark = 1;

	/* g̃JEgƁA㉺Eւ̍ċǍʂZB */
	return 1 + erase_scan(col, row - 1, color)
		 + erase_scan(col, row + 1, color)
		 + erase_scan(col - 1, row, color)
		 + erase_scan(col + 1, row, color);
}

/****************************************************************************
 *	erase_setup
 ****************************************************************************/

int
erase_setup(int col, int row, int color)
{
	CELL* cell;

	if(col < 0 || col > FIELD_COLS - 1) return 0; /* tB[hO */
	if(row < 0 || row > FIELD_ROWS - 1) return 0; /* tB[hO */
	cell = &game.field[row][col];
	if(!cell->color) return 0; /* 󂫃Z */
	if(cell->color != color) return 0; /* FႤ */
	if(cell->stat == CS_ERASE) return 0; /* ɏŏ */

	/* ŊJnB */
	cell->stat = CS_ERASE;
	cell->cnt = 0;

	/* g̃JEgƁA㉺Eւ̍ċǍʂZB */
	return 1 + erase_setup(col, row - 1, color)
		 + erase_setup(col, row + 1, color)
		 + erase_setup(col - 1, row, color)
		 + erase_setup(col + 1, row, color);
}

/****************************************************************************
 *	field_action
 ****************************************************************************/

void
field_action()
{
	int i;
	int n;
	int col;
	int row;
	CELL* cell;

	/*** ŒtF[Y ***/

	/* ŒtF[Ył́ACELL.markŒ}[NƂėp܂B */

	/* ܂ASubŇŒ}[NNA܂B */
	for(i = 0, cell = &game.field[0][0];
	    i < FIELD_COLS * FIELD_ROWS;
	    i++, cell++) {
		cell->mark = 0;
	}

	/* ŉsubN܂͐UorŃubN_ƂāAǂubNŒ}[N܂B */
	for(row = FIELD_ROWS - 1; row >= 0; row--) { /* ͂ǂł悢 */
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			if((row == FIELD_ROWS - 1) || (cell->stat == CS_QUAKE) || (cell->stat == CS_ERASE)) {
				fix_scan(col, row, 0/*ւ̑*/);
			}
		}
	}

	/*{{̎菇𓥂܂ȂƁAUO̒ʏubN֗ĂubNAʏubNɏdȂĂ܂܂B*/

	/* Œ肳ĂȂʏubNUJn܂B */
	for(row = FIELD_ROWS - 1; row >= 0; row--) { /* ͂ǂł悢 */
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			if((cell->stat == CS_NORMAL) && (!cell->mark)) {
				cell->stat = CS_QUAKE;
				cell->cnt = 0;

			}
		}
	}

	/* ܐUJnubN_ƂāAǂubNŒ}[N܂B */
	for(row = FIELD_ROWS - 1; row >= 0; row--) { /* ͂ǂł悢 */
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			if((cell->stat == CS_QUAKE) && (!cell->mark)) {
				fix_scan(col, row, 0/*ւ̑*/);
			}
		}
	}

	/*}}̎菇𓥂܂ȂƁAUO̒ʏubN֗ĂubNAʏubNɏdȂĂ܂܂B*/

	/*** tF[Y ***/

	/* ŒtF[Ył́ACELL.markŒ}[NƂėp܂B */

	for(row = FIELD_ROWS - 1; row >= 0; row--) { /* ͉K{!! */
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			switch(cell->stat) {
			case CS_QUAKE:
				cell->cnt++;
				if(cell->cnt >= QUAKE_TIME) { /* 莞Ԍo */
					/* ̃ZֈړAJnB */
					cell->stat = CS_FALL;
					cell->cnt = FALL_SPEED;
					/*{{G[o*/
					/* ŉsubN͕KŒ肳͂Ȃ̂ŁAUԂɂȂ邱Ƃ͂肦ȂB */
					if(row + 1 > FIELD_ROWS - 1) DIE();
					/* ŒubN̏̃ubNUA㉺ɕ񂾐UubN̏ゾɗJn邱Ƃ͂肦ȂB
					 * A㉺ɕŐUJnubN̂AБ̃ubNrŏŏԂֈڍs\͂B
					 * ̃ubNŏԂֈڍsꍇA㑤̃ubN͉̏ŃubN㏑ėJn邱ƂɂB
					 * ̃ubN͏ŊJn̏uԂɃXRAZĂ͂ŁAŏԂ̓GtFNĝ߂Ȃ̂ŁA
					 * ȂƎv܂B
					 */
					if((cell + FIELD_COLS)->color && ((cell + FIELD_COLS)->stat != CS_ERASE)) {
						die("ERR QUAKE: %d,%d,%d,%d",
							(cell + FIELD_COLS)->color,
							(cell + FIELD_COLS)->stat,
							(cell + FIELD_COLS)->cnt,
							(cell + FIELD_COLS)->mark);
					}
					/*}}G[o*/
					memcpy(cell + FIELD_COLS, cell, sizeof(CELL));
					memset(cell, 0, sizeof(CELL));
				}
				break;

			case CS_FALL:
				cell->cnt += FALL_SPEED;
				if(cell->cnt >= CELL_SIZE) { /* ZEz */
					if(!cell->mark) { /* Œ肳ĂȂ */
						/* ̃ZֈړApB */
						cell->cnt -= CELL_SIZE;
						/*{{G[o*/
						/* ŉsubN͕KŒ肳͂Ȃ̂ŁAԂɂȂ邱Ƃ͂肦ȂB */
						if(row + 1 > FIELD_ROWS - 1) DIE();
						/* ŒubN̗̏ubNŒ肳ꂸɁAubNEzėp邱Ƃ͂肦ȂB */
						if((cell + FIELD_COLS)->color) {
							die("ERR FALL: %d,%d,%d,%d",
								(cell + FIELD_COLS)->color,
								(cell + FIELD_COLS)->stat,
								(cell + FIELD_COLS)->cnt,
								(cell + FIELD_COLS)->mark);
						}
						/*}}G[o*/
						memcpy(cell + FIELD_COLS, cell, sizeof(CELL));
						memset(cell, 0, sizeof(CELL));
					} else {
						/* ڒnorڒB */
						cell->stat = CS_LAND;
					}
				}
				break;
			}
		}
	}

	/*** ŃtF[Y ***/

	/* ŃtF[Ył́ACELL.markerase_scan()̑ς݃}[NƂėp܂B
	 * erase_setup()̑ς݃}[ŃACELL.markł͂ȂCELL.stat==CS_ERASEp܂B
	 */

	/* ܂ASubN̑}[NNA܂B */
	for(i = 0, cell = &game.field[0][0];
	    i < FIELD_COLS * FIELD_ROWS;
	    i++, cell++) {
		cell->mark = 0;
	}

	/* ŏԈȊO̓FubNAڒnorڒԂȂƂȏ܂ŎlȏאڂĂAł܂B
	 * ƁAڒnorڒԂ_ƂāAŏԈȊO̓FubNlȏאڂĂAł܂B
	 */
	for(row = FIELD_ROWS - 1; row >= 0; row--) { /* ͂ǂł悢 */
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			switch(cell->stat) {
			case CS_ERASE:
				if(!cell->mark) { /* ݂̏ŃtF[YɂďŊJnZ͏Ȃ */
					/* ŌpB */
					cell->cnt++;
					if(cell->cnt >= ERASE_TIME) {
						/* ŊB */
						memset(cell, 0, sizeof(CELL));
					}
				}
				break;

			case CS_LAND:
				if(IS_BLOCK(cell->color)) {
					/* ŔB */
					n = erase_scan(col, row, cell->color);
					if(n >= 4) {
						/* ŊJnB */
						erase_setup(col, row, cell->color);
					} else {
						/* ʏԂֈڍsB */
						cell->stat = CS_NORMAL;
					}
				} else {
					/* GAJvŹAPɒʏԂֈڍsB(YȂ!!) */
					cell->stat = CS_NORMAL;
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static int quake_table[8] = { 1, 2, 1, 0, -1, -2, -1, 0 };

void
field_disp()
{
	int x;
	int y;
	int col;
	int row;
	int sprno;
	CELL* cell;

	sprite_draw(0, 0, SPR_BG, 0);

	/*** C1 ***/

	for(row = UPPER_ROWS; row < UPPER_ROWS + INNER_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			/* \ʒu߂܂B */
			x = FIELD_X + col * CELL_SIZE;
			y = FIELD_Y + row * CELL_SIZE - game.scroll_ofs;

			/* \p^[߂܂B */
			sprno = -1;
			switch(cell->color) {
			case CC_BLOCK1:
			case CC_BLOCK2:
			case CC_BLOCK3:
			case CC_BLOCK4:
			case CC_BLOCKX:
				switch(cell->stat) {
				case CS_FALL:
					y += cell->cnt - CELL_SIZE;
					/* FALLTHROUGH */
				case CS_NORMAL:
					sprno = SPR_BLOCK10 + (cell->color - CC_BLOCK1) * 16;
					if(cell->color == CC_BLOCKX) sprno += cell->dmg * 16;
					if((col < FIELD_COLS - 1) && ((cell +          1)->color == cell->color) && ((cell +          1)->stat == cell->stat)) sprno += 1 << 0;
					if((col >              0) && ((cell -          1)->color == cell->color) && ((cell -          1)->stat == cell->stat)) sprno += 1 << 1;
					if((row < FIELD_ROWS - 1) && ((cell + FIELD_COLS)->color == cell->color) && ((cell + FIELD_COLS)->stat == cell->stat)) sprno += 1 << 2;
					if((row >              0) && ((cell - FIELD_COLS)->color == cell->color) && ((cell - FIELD_COLS)->stat == cell->stat)) sprno += 1 << 3;
					break;
				}
				break;

			case CC_AIR:
				switch(cell->stat) {
				case CS_FALL:
					y += cell->cnt - CELL_SIZE;
					/* FALLTHROUGH */
				case CS_NORMAL:
					sprno = SPR_AIR0;
					switch(now / 2 & 7) {
					case 1: sprno += 1; break;
					case 2: sprno += 2; break;
					case 3: sprno += 3; break;
					}
					break;
				}
				break;
			}

			/* \܂B */
			if(sprno != -1) {
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/*** C2 ***/

	for(row = UPPER_ROWS; row < UPPER_ROWS + INNER_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			/* \ʒu߂܂B */
			x = FIELD_X + col * CELL_SIZE;
			y = FIELD_Y + row * CELL_SIZE - game.scroll_ofs;

			/* \p^[߂܂B */
			sprno = -1;
			switch(cell->color) {
			case CC_BLOCK1:
			case CC_BLOCK2:
			case CC_BLOCK3:
			case CC_BLOCK4:
			case CC_BLOCKX:
				switch(cell->stat) {
				case CS_QUAKE:
					x += quake_table[cell->cnt & 7];
					sprno = SPR_BLOCK10 + (cell->color - CC_BLOCK1) * 16;
					if(cell->color == CC_BLOCKX) sprno += cell->dmg * 16;
					if((col < FIELD_COLS - 1) && ((cell +          1)->color == cell->color) && ((cell +          1)->stat == cell->stat)) sprno += 1 << 0;
					if((col >              0) && ((cell -          1)->color == cell->color) && ((cell -          1)->stat == cell->stat)) sprno += 1 << 1;
					if((row < FIELD_ROWS - 1) && ((cell + FIELD_COLS)->color == cell->color) && ((cell + FIELD_COLS)->stat == cell->stat)) sprno += 1 << 2;
					if((row >              0) && ((cell - FIELD_COLS)->color == cell->color) && ((cell - FIELD_COLS)->stat == cell->stat)) sprno += 1 << 3;
					break;
				}
				break;

			case CC_AIR:
				switch(cell->stat) {
				case CS_QUAKE:
					x += quake_table[cell->cnt & 7];
					sprno = SPR_AIR0;
					switch(now / 2 & 7) {
					case 1: sprno += 1; break;
					case 2: sprno += 2; break;
					case 3: sprno += 3; break;
					}
					break;
				}
				break;
			}

			/* \܂B */
			if(sprno != -1) {
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/*** C3 ***/

	for(row = UPPER_ROWS; row < UPPER_ROWS + INNER_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			/* \ʒu߂܂B */
			x = FIELD_X + col * CELL_SIZE;
			y = FIELD_Y + row * CELL_SIZE - game.scroll_ofs;

			/* \p^[߂܂B */
			sprno = -1;
			switch(cell->color) {
			case CC_BLOCK1:
			case CC_BLOCK2:
			case CC_BLOCK3:
			case CC_BLOCK4:
			case CC_BLOCKX:
				switch(cell->stat) {
				case CS_ERASE:
					if(cell->cnt < 8) {
						sprno = SPR_ERASE10 + (cell->color - CC_BLOCK1) * 8;
						sprno += cell->cnt;
					}
					break;
				}
				break;
			}

			/* \܂B */
			if(sprno != -1) {
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* vC[\B */
	player_disp();

	/*** C4 ***/

	for(row = UPPER_ROWS; row < UPPER_ROWS + INNER_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->color) continue; /* 󂫃Z */

			/* \ʒu߂܂B */
			x = FIELD_X + col * CELL_SIZE;
			y = FIELD_Y + row * CELL_SIZE - game.scroll_ofs;

			/* \p^[߂܂B */
			sprno = -1;
			switch(cell->color) {
			case CC_BLOCK1:
			case CC_BLOCK2:
			case CC_BLOCK3:
			case CC_BLOCK4:
			case CC_BLOCKX:
				switch(cell->stat) {
				case CS_ERASE:
					if(cell->cnt < 8) {
						sprno = SPR_EFFECT0;
						sprno += cell->cnt;
					}
					break;
				}
				break;
			}

			/* \܂B */
			if(sprno != -1) {
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* [xQ[W\B */
	x = 74;
	y = FIELD_Y - game.scroll_ofs;
	for(row = 0; row < FIELD_ROWS; row++) {
		if((game.scroll_depth + row + PLAYER_ROW - 1) % 10) {
			render_line(&render, x + 3, y, x + 6, y, 3);
		} else {
			render_line(&render, x + 0, y, x + 6, y, 0);
		}
		y += CELL_SIZE;
	}

	/* XRA\B */
	score_disp();
}

/****************************************************************************
 *	scroll
 ****************************************************************************/

static const short block_gen_table[] = { CC_BLOCK1, CC_BLOCK2, CC_BLOCK4, CC_BLOCK3 };

static int
block_gen(int ref_color)
{
	int n;
	int color;

	n = RND16_RANGE(game.gen_seed, 0, 100);
	if(n < game.x_rate) {
		/* ~ubN𐶐B */
		return CC_BLOCKX;
	}

	n = ref_color - CC_BLOCK1;
	if((n >= 0) && (n <= game.color_num - 1)) { /* LȗאڐFw肠 */
		n = RND16_RANGE(game.gen_seed, 0, 100);
		if(n < game.same_rate) {
			/* אړFubN𐶐B */
			return ref_color;
		}
	}

	if(game.color_num == 1) {
		/* F[hB */
		color = block_gen_table[0];
	} else {
		/* אڐFubN𐶐B */
		do {
			n = RND16_RANGE(game.gen_seed, 0, game.color_num);
			color = block_gen_table[n];
		} while(color == ref_color);
	}
	return color;
}

void
scroll_action()
{
	int n;
	int col;
	int ref_color;

	while(game.scroll_ofs >= CELL_SIZE) {
		game.scroll_ofs -= CELL_SIZE;

		/* vC[ʒuB */
		game.player_y -= CELL_SIZE;
		if(game.player_y < 0) game.player_y = 0; /* ɈӖȂ */

		/* XN[[xB */
		game.scroll_depth++;

		/* xB */
		game.level = 1 + (game.scroll_depth / 100);
		if(game.level <   1) game.level =   1;
		if(game.level > 999) game.level = 999;
		level_setup();

		/* XN[AbvB */
		memmove(&game.field[0][0], &game.field[1][0], sizeof(CELL) * FIELD_COLS * (FIELD_ROWS - 1));

		/* ŉsubNB */
		memset(&game.field[FIELD_ROWS - 1][0], 0, sizeof(CELL) * FIELD_COLS);
		for(col = 0; col < FIELD_COLS; col++) {
			if(col == 0) {
				n = RND16_RANGE(game.gen_seed, 0, 3);
				switch(n) {
				case 0: ref_color = game.field[FIELD_ROWS - 1][col - 1].color; break;
				case 1: ref_color = game.field[FIELD_ROWS - 2][col    ].color; break;
				case 2: ref_color = game.field[FIELD_ROWS - 2][col + 1].color; break;
				default: DIE();
				}
			} else if(col == FIELD_COLS - 1) {
				n = RND16_RANGE(game.gen_seed, 0, 3);
				switch(n) {
				case 0: ref_color = game.field[FIELD_ROWS - 1][col - 1].color; break;
				case 1: ref_color = game.field[FIELD_ROWS - 2][col    ].color; break;
				case 2: ref_color = game.field[FIELD_ROWS - 2][col - 1].color; break;
				default: DIE();
				}
			} else {
				n = RND16_RANGE(game.gen_seed, 0, 4);
				switch(n) {
				case 0: ref_color = game.field[FIELD_ROWS - 1][col - 1].color; break;
				case 1: ref_color = game.field[FIELD_ROWS - 2][col - 1].color; break;
				case 2: ref_color = game.field[FIELD_ROWS - 2][col    ].color; break;
				case 3: ref_color = game.field[FIELD_ROWS - 2][col + 1].color; break;
				default: DIE();
				}
			}
			game.field[FIELD_ROWS - 1][col].color = block_gen(ref_color);
		}

		/* GAJvZB */
		game.air_gen_cnt++;
		if(game.air_gen_cnt >= game.air_gen_interval) {
			game.air_gen_cnt = 0;
			col = RND16_RANGE(game.gen_seed, 0, FIELD_COLS);
			game.field[FIELD_ROWS - 1][col].color = CC_AIR;
		}
	}
}

/****************************************************************************
 *	jump_test
 ****************************************************************************/

int
jump_test(int col, int row, int dir)
{
	if(col < 0 || col > FIELD_COLS - 1) DIE();
	if(row < 0 || row > FIELD_ROWS - 1) DIE();

	if(row - 1 < 0) return 0;

	switch(dir) {
	case DIR_RI:
		/* EWvsoB */
		if(col + 1 > FIELD_COLS - 1) return 0;
		if(!IS_BLOCK(game.field[row    ][col + 1].color) || (game.field[row    ][col + 1].stat == CS_ERASE)) return 0; /* EZJ */
		if( IS_BLOCK(game.field[row - 1][col    ].color) && (game.field[row - 1][col    ].stat != CS_ERASE)) return 0; /* ZJłȂ */
		if( IS_BLOCK(game.field[row - 1][col + 1].color) && (game.field[row - 1][col + 1].stat != CS_ERASE)) return 0; /* EZJłȂ */
		break;

	case DIR_LF:
		/* WvsoB */
		if(col - 1 < 0) return 0;
		if(!IS_BLOCK(game.field[row    ][col - 1].color) || (game.field[row    ][col - 1].stat == CS_ERASE)) return 0; /* ZJ */
		if( IS_BLOCK(game.field[row - 1][col    ].color) && (game.field[row - 1][col    ].stat != CS_ERASE)) return 0; /* ZJłȂ */
		if( IS_BLOCK(game.field[row - 1][col - 1].color) && (game.field[row - 1][col - 1].stat != CS_ERASE)) return 0; /* ZJłȂ */
		break;

	default:
		DIE();
	}

	return 1;
}

/****************************************************************************
 *	player_action
 ****************************************************************************/

void
player_action()
{
	int col;
	int row;
	int x_ofs;
	int y_ofs;
	CELL* cell;

	if((game.player_x < 0) || (game.player_x > (FIELD_COLS - 1) * CELL_SIZE)) DIE();
	if((game.player_y < 0) || (game.player_y > (FIELD_ROWS - 1) * CELL_SIZE)) DIE();
	col = (game.player_x + CELL_HALF    ) / CELL_SIZE;
	row = (game.player_y + CELL_SIZE - 1) / CELL_SIZE;
	x_ofs = game.player_x - col * CELL_SIZE;
	y_ofs = game.player_y - row * CELL_SIZE;

	/********************/
	/***** ʏ *****/
	/********************/

	if(game.player_stat != PS_MISS) {
		/* GA擾B */
		cell = &game.field[row][col];
		if(cell->color == CC_AIR) {
			memset(cell, 0, sizeof(CELL));
			game.air_dec_cnt = 0; /* 擾ɌȂ悤 */
			game.air += 20;
			if(game.air > 100) game.air = 100;
			/* bZ[W\B */
			game.msg = 1;
			game.msg_cnt = SEC(2);
		}

		/* GAB */
		game.air_dec_cnt++;
		if(game.air_dec_cnt >= game.air_dec_interval) {
			game.air_dec_cnt = 0;
			game.air--;
			if(game.air < 0) game.air = 0;
			if(!game.air) { /* GA؂ */
				/* ~XԂֈڍsB */
				game.player_stat = PS_MISS;
				game.player_cnt = 0;
				goto L_EXIT;
			}
		}
	}

	/* Wv҂JE^̃Zbgł܂Ƃ߂čs܂B */
	if(game.player_stat != PS_WALK) {
		game.jump_cnt = 0;
	}

	switch(game.player_stat) {
	case PS_STOP: /* Î~ */
	case PS_WALK: /* s */
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* ͂˔΂E蔻B */
		cell = &game.field[row][col];
		if(IS_BLOCK(cell->color) &&
		   ((cell->stat == CS_NORMAL) ||
		    (cell->stat == CS_QUAKE) ||
		    (cell->stat == CS_FALL && cell->cnt >= CELL_HALF))) {
			if(x_ofs < 0) { /* ͂˔΂ */
				if(col - 1 >= 0) {
					cell = &game.field[row][col - 1];
					if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
						switch(game.player_dir) {
						case DIR_RI:
							game.player_stat = PS_HITB;
							game.player_cnt = 0;
							goto L_EXIT;
						case DIR_LF:
							game.player_stat = PS_HITF;
							game.player_cnt = 0;
							goto L_EXIT;
						case DIR_DN: /* Kv!! */
						case DIR_UP: /* Kv!! */
							game.player_dir = DIR_LF;
							game.player_stat = PS_HITF;
							game.player_cnt = 0;
							goto L_EXIT;
						default:
							DIE();
						}
					}
				}
			} else if(x_ofs > 0) { /* E͂˔΂ */
				if(col + 1 <= FIELD_COLS - 1) {
					cell = &game.field[row][col + 1];
					if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
						switch(game.player_dir) {
						case DIR_RI:
							game.player_stat = PS_HITF;
							game.player_cnt = 0;
							goto L_EXIT;
						case DIR_LF:
							game.player_stat = PS_HITB;
							game.player_cnt = 0;
							goto L_EXIT;
						case DIR_DN: /* Kv!! */
						case DIR_UP: /* Kv!! */
							game.player_dir = DIR_RI;
							game.player_stat = PS_HITF;
							game.player_cnt = 0;
							goto L_EXIT;
						default:
							DIE();
						}
					}
				}
			}

			/* ~XԂֈڍsB */
			game.player_stat = PS_MISS;
			game.player_cnt = 0;
			goto L_EXIT;
		}

		break;
	}

	switch(game.player_stat) {
	case PS_STOP: /* Î~ */
	case PS_WALK: /* s */
	case PS_HITF: /* O͂˔΂ */
	case PS_HITB: /* ͂˔΂ */
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* ֈڍs̔B */
		if(row < FIELD_ROWS - 1) {
			cell = &game.field[row + 1][col];
			if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
				game.player_x -= x_ofs; /* ZE킹 */
				game.player_stat = PS_FALL;
				game.player_cnt = 0;
				goto L_EXIT;
			}
		}

		break;
	}

	switch(game.player_stat) {
	case PS_STOP: /* Î~ */
	case PS_WALK: /* s */
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* @ֈڍs̔B */
		if(joy & TRG_AB) {
			game.player_stat = PS_DIG;
			game.player_cnt = 0;
			goto L_EXIT;
		}

		break;
	}

	/********************/
	/***** ʏ *****/
	/********************/

	switch(game.player_stat) {

	/*** Î~ ***/
	case PS_STOP:
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* ʕ̐Î~܂͕sֈڍs̔B */
		switch(game.player_dir) {
		case DIR_RI:
			if(joy & PAD_RI) { game.player_stat = PS_WALK; game.player_cnt = 0; goto L_EXIT; }
			if(joy & PAD_LF) { game.player_dir = DIR_LF; goto L_EXIT; }
			if(joy & PAD_DN) { game.player_dir = DIR_DN; goto L_EXIT; }
			if(joy & PAD_UP) { game.player_dir = DIR_UP; goto L_EXIT; }
			break;
		case DIR_LF:
			if(joy & PAD_RI) { game.player_dir = DIR_RI; goto L_EXIT; }
			if(joy & PAD_LF) { game.player_stat = PS_WALK; game.player_cnt = 0; goto L_EXIT; }
			if(joy & PAD_DN) { game.player_dir = DIR_DN; goto L_EXIT; }
			if(joy & PAD_UP) { game.player_dir = DIR_UP; goto L_EXIT; }
			break;
		case DIR_DN:
			if(joy & PAD_RI) { game.player_dir = DIR_RI; goto L_EXIT; }
			if(joy & PAD_LF) { game.player_dir = DIR_LF; goto L_EXIT; }
			if(joy & PAD_DN) { /** no job **/ goto L_EXIT; }
			if(joy & PAD_UP) { game.player_dir = DIR_UP; goto L_EXIT; }
			break;
		case DIR_UP:
			if(joy & PAD_LF) { game.player_dir = DIR_LF; goto L_EXIT; }
			if(joy & PAD_RI) { game.player_dir = DIR_RI; goto L_EXIT; }
			if(joy & PAD_DN) { game.player_dir = DIR_DN; goto L_EXIT; }
			if(joy & PAD_UP) { /** no job **/ goto L_EXIT; }
			break;
		default:
			DIE();
		}

		break;

	/*** s ***/
	case PS_WALK:
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* Aj[VJE^isB */
		game.player_cnt++;

		switch(game.player_dir) {
		case DIR_RI:
			if(joy & PAD_RI) {
				/* ݃Z̍ł̈ړB */
				if(x_ofs + WALK_SPEED <= 0) {
					game.player_x += WALK_SPEED;
					goto L_EXIT;

				/* ݃Z̍EցA܂͉EA܂͉EZւ̈ړB */
				} else {
					/* ݁AtB[hE[ZłȂB */
					if(col + 1 <= FIELD_COLS - 1) {
						cell = &game.field[row][col + 1];

						/* EZJB */
						if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
							game.player_x += WALK_SPEED;
							goto L_EXIT;

						/* EZJłȂB */
						} else {
							/* ݃Z̍璆܂ł̈ړB */
							if(x_ofs < 0) game.player_x -= x_ofs;

							/* WvB */
							if(jump_test(col, row, game.player_dir)) {
								game.jump_cnt++;
								if(game.jump_cnt >= JUMP_DELAY) {
									game.player_stat = PS_JUMP;
									game.player_cnt = 0;
									goto L_EXIT;
								} else {
									/* WvO[VێB */
									goto L_EXIT;
								}
							} else {
								/* Î~ֈڍsB */
								game.player_stat = PS_STOP;
								goto L_EXIT;
							}
						}
					}

					/* ݃Z̍璆܂ł̈ړB */
					if(x_ofs < 0) {
						game.player_x -= x_ofs;
					}
					/* Î~ֈڍs */
				}
			}
			game.player_stat = PS_STOP;
			goto L_EXIT;

			break;

		case DIR_LF:
			if(joy & PAD_LF) {
				/* ݃Z̉Eł̈ړB */
				if(x_ofs - WALK_SPEED >= 0) {
					game.player_x -= WALK_SPEED;
					goto L_EXIT;

				/* ݃Z̉E獶ցA܂͍A܂͍Zւ̈ړB */
				} else {
					/* ݁AtB[h[ZłȂB */
					if(col - 1 >= 0) {
						cell = &game.field[row][col - 1];

						/* ZJB */
						if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
							game.player_x -= WALK_SPEED;
							goto L_EXIT;

						/* ZJłȂB */
						} else {
							/* ݃Z̉E璆܂ł̈ړB */
							if(x_ofs > 0) game.player_x -= x_ofs;

							/* WvB */
							if(jump_test(col, row, game.player_dir)) {
								game.jump_cnt++;
								if(game.jump_cnt >= JUMP_DELAY) {
									game.player_stat = PS_JUMP;
									game.player_cnt = 0;
									goto L_EXIT;
								} else {
									/* WvO[VێB */
									goto L_EXIT;
								}
							} else {
								/* Î~ֈڍsB */
								game.player_stat = PS_STOP;
								goto L_EXIT;
							}
						}
					}

					/* ݃Z̉E璆܂ł̈ړB */
					if(x_ofs > 0) {
						game.player_x -= x_ofs;
					}
					/* Î~ֈڍs */
				}
			}
			game.player_stat = PS_STOP;
			goto L_EXIT;

			break;

		default:
			DIE();
		}

		break;

	/*** @ ***/
	case PS_DIG:
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* [VJE^isB */
		game.player_cnt++;

		/* ubNŁB */
		if(game.player_cnt == 1) {
			switch(game.player_dir) {
			case DIR_RI:
				if(col + 1 <= FIELD_COLS - 1) {
					cell = &game.field[row][col + 1];
					if(IS_BLOCK(cell->color) && (cell->stat == CS_NORMAL || cell->stat == CS_QUAKE)) {
						if(cell->color == CC_BLOCKX) {
							if(cell->dmg + 1 < 5) {
								cell->dmg++;
							} else {
								cell->stat = CS_ERASE;
								cell->cnt = 0;
								/* GAB */
								game.air_dec_cnt = 0;
								game.air -= 20;
								if(game.air < 1) game.air = 1;
								/* bZ[W\B */
								game.msg = 2;
								game.msg_cnt = SEC(2);
							}
						} else {
							erase_setup(col + 1, row, cell->color);
						}
					}
				}
				break;
			case DIR_LF:
				if(col - 1 >= 0) {
					cell = &game.field[row][col - 1];
					if(IS_BLOCK(cell->color) && (cell->stat == CS_NORMAL || cell->stat == CS_QUAKE)) {
						if(cell->color == CC_BLOCKX) {
							if(cell->dmg + 1 < 5) {
								cell->dmg++;
							} else {
								cell->stat = CS_ERASE;
								cell->cnt = 0;
								/* GAB */
								game.air_dec_cnt = 0;
								game.air -= 20;
								if(game.air < 1) game.air = 1;
								/* bZ[W\B */
								game.msg = 2;
								game.msg_cnt = SEC(2);
							}
						} else {
							erase_setup(col - 1, row, cell->color);
						}
					}
				}
				break;
			case DIR_DN:
				if(row + 1 <= FIELD_ROWS - 1) {
					cell = &game.field[row + 1][col];
					if(IS_BLOCK(cell->color) && (cell->stat == CS_NORMAL || cell->stat == CS_QUAKE)) {
						if(cell->color == CC_BLOCKX) {
							if(cell->dmg + 1 < 5) {
								cell->dmg++;
							} else {
								cell->stat = CS_ERASE;
								cell->cnt = 0;
								/* GAB */
								game.air_dec_cnt = 0;
								game.air -= 20;
								if(game.air < 1) game.air = 1;
								/* bZ[W\B */
								game.msg = 2;
								game.msg_cnt = SEC(2);
							}
						} else {
							erase_setup(col, row + 1, cell->color);
						}
					}
				}
				break;
			case DIR_UP:
				if(row - 1 >= 0) {
					cell = &game.field[row - 1][col];
					if(IS_BLOCK(cell->color) && (cell->stat == CS_NORMAL || cell->stat == CS_QUAKE)) {
						if(cell->color == CC_BLOCKX) {
							if(cell->dmg + 1 < 5) {
								cell->dmg++;
							} else {
								cell->stat = CS_ERASE;
								cell->cnt = 0;
								/* GAB */
								game.air_dec_cnt = 0;
								game.air -= 20;
								if(game.air < 1) game.air = 1;
								/* bZ[W\B */
								game.msg = 2;
								game.msg_cnt = SEC(2);
							}
						} else {
							erase_setup(col, row - 1, cell->color);
						}
					}
				}
				break;
			default:
				DIE();
			}
		}

		/* [VB */
		if(game.player_cnt >= 3) {
			game.player_stat = PS_STOP;
			goto L_EXIT;
		}

		break;

	/*** Wv ***/
	case PS_JUMP:
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* [VJE^isB */
		game.player_cnt++;

		/* [VB */
		if(game.player_cnt >= 6) {
			switch(game.player_dir) {
			case DIR_RI:
				/* EZֈړB */
				game.player_x += CELL_SIZE;
				game.player_y -= CELL_SIZE;
				break;
			case DIR_LF:
				/* ZֈړB */
				game.player_x -= CELL_SIZE;
				game.player_y -= CELL_SIZE;
				break;
			default:
				DIE();
			}

			/* sԂֈڍsB */
			game.player_stat = PS_WALK;
			game.player_cnt = 0;
			goto L_EXIT;
		}

		break;


	/***  ***/
	case PS_FALL:

		/* Aj[VJE^isB */
		game.player_cnt++;

		/* ZEł̈ړB */
		if(y_ofs + FALL_SPEED < 0) {
			game.player_y += FALL_SPEED;
			goto L_EXIT;

		/* ZEzړB */
		} else {
			if(row + 1 <= FIELD_ROWS - 1) {
				cell = &game.field[row + 1][col];

				/* ZJB */
				if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
					game.player_y += FALL_SPEED;
					goto L_EXIT;
				}
			}

			/* ڒnB */
			game.player_y -= y_ofs;
			/* Î~ֈڍs */
		}
		game.player_stat = PS_STOP;
		goto L_EXIT;

		break;

	/*** O͂˔΂ ***/
	case PS_HITF:
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* [VJE^isB */
		game.player_cnt++;

		switch(game.player_cnt) {
		case 1:
		case 2:
			/* ړB */
			switch(game.player_dir) {
			case DIR_RI:
				game.player_x += CELL_SIZE / 4;
				break;
			case DIR_LF:
				game.player_x -= CELL_SIZE / 4;
				break;
			default:
				DIE();
			}
			break;
		case HIT_TIME:
			/* Î~ԂֈڍsB */
			game.player_stat = PS_STOP;
			goto L_EXIT;
		}

		break;

	/*** ͂˔΂ ***/
	case PS_HITB:
		if(y_ofs) DIE(); /* KZEɐ񂵂Ă͂ */

		/* [VJE^isB */
		game.player_cnt++;

		switch(game.player_cnt) {
		case 1:
		case 2:
			/* ړB */
			switch(game.player_dir) {
			case DIR_RI:
				game.player_x -= CELL_SIZE / 4;
				break;
			case DIR_LF:
				game.player_x += CELL_SIZE / 4;
				break;
			default:
				DIE();
			}
			break;
		case HIT_TIME:
			/* Î~ԂֈڍsB */
			game.player_stat = PS_STOP;
			goto L_EXIT;
		}

		break;

	/*** ~X ***/
	case PS_MISS:

		/* [VJE^isB */
		game.player_cnt++;

		/* ~Xԕ\AɃubNȂΗ܂B */

		/* ZEł̈ړB */
		if(y_ofs + FALL_SPEED < 0) {
			game.player_y += FALL_SPEED;
			goto L_EXIT;

		/* ZEzړB */
		} else {
			if(row + 1 <= FIELD_ROWS - 1) {
				cell = &game.field[row + 1][col];

				/* ZJB */
				if(!IS_BLOCK(cell->color) || (cell->stat == CS_ERASE)) {
					game.player_y += FALL_SPEED;
					goto L_EXIT;
				}
			}

			/* ڒnB */
			game.player_y -= y_ofs;
		}

		break;

	default:
		DIE();
	}
L_EXIT:

	/* vC[[xvZB */
	game.depth = game.scroll_depth + (game.player_y / CELL_SIZE - PLAYER_ROW);
	if(game.depth < 0) game.depth = 0;

	/* R[hXVB */
	if(game.depth > record) record = game.depth;
}

/****************************************************************************
 *	player_disp
 ****************************************************************************/

static const short pat_stop[4] = {
	SPR_STOPRI,
	SPR_STOPLF,
	SPR_STOPDN,
	SPR_STOPUP,
};
static const short pat_walk[4][4] = {
	{ SPR_STOPRI, SPR_WALKRI0, SPR_WALKRI1, SPR_WALKRI2 },
	{ SPR_STOPLF, SPR_WALKLF0, SPR_WALKLF1, SPR_WALKLF2 },
	{ -1, -1, -1, -1 },
	{ -1, -1, -1, -1 },
};
static const short pat_dig[4][3] = {
	{ SPR_DIGRI0, SPR_DIGRI1, SPR_DIGRI0 },
	{ SPR_DIGLF0, SPR_DIGLF1, SPR_DIGLF0 },
	{ SPR_DIGDN0, SPR_DIGDN1, SPR_DIGDN0 },
	{ SPR_DIGUP0, SPR_DIGUP1, SPR_DIGUP0 },
};
typedef struct _JUMPPAT {
	char x;
	char y;
	short sprno;
} JUMPPAT;
static const JUMPPAT pat_jump[2][7] = {
	{ {  0, -2, SPR_JUMPRI1 },
	  {  0, -4, SPR_JUMPRI1 },
	  {  0, -6, SPR_JUMPRI1 },
	  {  2, -8, SPR_JUMPRI0 },
	  {  4, -8, SPR_JUMPRI0 },
	  {  6, -8, SPR_JUMPRI0 } },
	{ {  0, -2, SPR_JUMPLF1 },
	  {  0, -4, SPR_JUMPLF1 },
	  {  0, -6, SPR_JUMPLF1 },
	  { -2, -8, SPR_JUMPLF0 },
	  { -4, -8, SPR_JUMPLF0 },
	  { -6, -8, SPR_JUMPLF0 } },
};
static const short pat_hitf[2][2] = {
	{ SPR_HITFRI0, SPR_HITFRI1 },
	{ SPR_HITFLF0, SPR_HITFLF1 },
};
static const short pat_hitb[2][2] = {
	{ SPR_HITBRI0, SPR_HITBRI1 },
	{ SPR_HITBLF0, SPR_HITBLF1 },
};

void
player_disp()
{
	int i;
	int x;
	int y;
	int sprno;

	x = FIELD_X + game.player_x;
	y = FIELD_Y + game.player_y - game.scroll_ofs;
	sprno = -1;

	switch(game.player_stat) {

	/*** ~ ***/
	case PS_STOP:
		sprno = pat_stop[game.player_dir];
		break;

	/*** s ***/
	case PS_WALK:
		if(!game.jump_cnt) {
			sprno = pat_walk[game.player_dir][game.player_cnt & 3];
		} else {
			switch(game.player_dir) {
			case DIR_RI: sprno = SPR_JUMPRI0; break;
			case DIR_LF: sprno = SPR_JUMPLF0; break;
			default: DIE();
			}
		}
		break;

	/*** @ ***/
	case PS_DIG:
		if(game.player_cnt < 3) {
			sprno = pat_dig[game.player_dir][game.player_cnt];
		} else {
			sprno = pat_stop[game.player_dir];
		}
		break;

	/*** Wv ***/
	case PS_JUMP:
		x    += pat_jump[game.player_dir][game.player_cnt].x;
		y    += pat_jump[game.player_dir][game.player_cnt].y;
		sprno = pat_jump[game.player_dir][game.player_cnt].sprno;
		break;

	/***  ***/
	case PS_FALL:
		sprno = SPR_FALL0 + (game.player_cnt / 4 & 1);
		break;

	/*** O͂˔΂ ***/
	case PS_HITF:
		i = game.player_cnt;
		if(i > 1) i = 1;
		sprno = pat_hitf[game.player_dir][i];
		break;

	/*** ͂˔΂ ***/
	case PS_HITB:
		i = game.player_cnt;
		if(i > 1) i = 1;
		sprno = pat_hitb[game.player_dir][i];
		break;

	/*** ~X ***/
	case PS_MISS:
		sprno = SPR_MISS;
		break;

	default:
		DIE();
	}

	if(sprno != -1) {
		sprite_draw(x, y, sprno, 0);
	}

	/* ~XVg\B */
	if(game.player_stat == PS_MISS) {
		if(game.player_cnt >= SEC(1)) {
			i = game.player_cnt - SEC(1);
			sprite_draw(
				x + fist(fimul(fsin(fidiv(fimul(PI2, i), SEC(2))), CELL_SIZE)),
				y - CELL_HALF - i / 2,
				SPR_ANGEL0 + (i / SEC(0.25) & 1), 0);
		}
	}

	/* bZ[W\B */
	if(game.player_stat != PS_MISS) {
		if(game.msg_cnt) {
			if(game.msg_cnt % SEC(0.5) >= SEC(0.2)) {
				switch(game.msg) {
				case 1:
					x -= 2;
					y -= 14;
					render_string_framed(&render, x, y, "AIR", 0x82, 0x203);
					y += 6;
					render_string_framed(&render, x, y, "+20", 0x82, 0x203);
					break;
				case 2:
					x -= 2;
					y -= 14;
					render_string_framed(&render, x, y, "AIR", 0x82, 0x213);
					y += 6;
					render_string_framed(&render, x, y, "-20", 0x82, 0x213);
					break;
				}
			}
			game.msg_cnt--;
		} else {
			if(game.air <= 9) {
				x += CELL_SIZE - 1;
				y -= 8 - 1;
				render_printf_framed(&render, x, y, 0x82, 0x213, "%d%%", game.air);
			}
		}
	}
}

/****************************************************************************
 *	score_disp
 ****************************************************************************/

void
score_disp()
{
	int n;
	int x;
	int y;
	char str[32];

	/* vC[[xB */
	x = 92;
	y = 8;
	n = sprintf(str, "%d", game.depth <= 9999 ? game.depth : 9999);
	render_rectangle_fill(&render, x + 5 * (4 - n), y, 5 * n, 11, 1);
	render_string_framed( &render, x + 5 * (4 - n), y, str, 0x80, 0x330);

	/* R[h[xB */
	x = 92;
	y = 28;
	n = sprintf(str, "%d", record <= 9999 ? record : 9999);
	render_rectangle_fill(&render, x + 5 * (4 - n), y, 5 * n, 11, 1);
	render_string_framed( &render, x + 5 * (4 - n), y, str, 0x80, 0x330);

	/* GAcB */
	x = 97;
	y = 56;
	n = sprintf(str, "%d", game.air);
	render_rectangle_fill(&render, x + 5 * (3 - n), y, 5 * n, 11, 1);
	render_string_framed( &render, x + 5 * (3 - n), y, str, 0x80, 0x330);

	x = 84;
	y = 51;
	n = (100 - game.air) * 40 / 100;
	render_rectangle_fill(&render, x, y, n, 3, 3);

	/* xB */
	x = 102;
	y =  76;
	n = sprintf(str, "%d", game.level);
	render_rectangle_fill(&render, x + 5 * (3 - n), y, 5 * n, 11, 1);
	render_string_framed( &render, x + 5 * (3 - n), y, str, 0x80, 0x330);
}

/****************************************************************************
 *	level_setup()
 ****************************************************************************/

void
level_setup()
{
	int level;

	if(game.level < 1 || game.level > 999) DIE(); /* scroll_action()ɂĐ؂lߍς݂̂͂ */
	level = game.level - 1;

	/* ubN̐FB */
	switch(level % 5) {
	case 0: game.color_num = 4; break;
	case 1: game.color_num = 3; break;
	case 2: game.color_num = 4; break;
	case 3: game.color_num = 3; break;
	case 4: game.color_num = 2; break;
	default: DIE();
	}

	/* ~ubNmB */
	game.x_rate = 15 + level / 3;
	if(game.x_rate > 30) game.x_rate = 30;

	/* FubNאڊmB */
	switch(level % 4) {
	case 0: game.same_rate = 50; break;
	case 1: game.same_rate = 40; break;
	case 2: game.same_rate = 60; break;
	case 3: game.same_rate = 30; break;
	default: DIE();
	}

	/* GACԊuB */
	game.air_gen_interval = 10 + level;
	if(game.air_gen_interval > 50) game.air_gen_interval = 50;

	/* GAt[ԊuB */
	game.air_dec_interval = SEC(1); /* Ƃ肠Œ */
}

